﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GenericFamilyRelation
{
    class GenericFamilyRelation<T> where T : Animal
    {
        public GenericFamilyRelation(T self, T father, T mother) 
        {
            Self = self;
            Father = father;
            Mother = mother;
            Children = new List<T>();
        }

        public GenericFamilyRelation(T self)
        {
            Self = self;
            Father = null;
            Mother = null;
            Children = new List<T>();
        }

        public T Self { get; }

        public T Father { get; }

        public T Mother { get; }

        public List<T> Children { get; }

        public void AddChild(T child)
        {
            Children.Add(child);
        }

        //Bemærk: T's Name property er ikke kendt i klassen, men hvis der sættes constraints på klassen fx Animal så er den 
        public string NameOfParents()
        {
            return Father.Name + " and " + Mother.Name;
        }
    }
}

